<?php
require "../../../../../db.php";
require "../../../../../mysql.php";

$res['msg'] = 'Error , Didn\'t receive data ..';

if(!empty($postdata)){

  $request = json_decode($postdata,true);
  $doctorId = $request["doctor_id"];
  $availableDays = $request["available_days"];

  $table = "available_days";
  foreach($availableDays as $availableDay){

    $availableDayRecord = checkIfDayIsFound($table,$doctorId,$availableDay["available_day"],$conn);
    
    $availableDay["doctor_id"] = $doctorId;
    $result = updateAaliableDay($availableDayRecord,$availableDay,$table,$conn);
  }

  $res['msg'] = $result;

}
 
echo json_encode($res);
mysqli_close($conn);

function updateAaliableDay($availableDayRecord,$availableDay,$table,$conn){

    $date = date("ds");
    $random = (string) rand(100, 999);
    $docId = $date.$random;
    
    //Add ID
    $availableDayId = $availableDay["doc_id"] ?? $docId;
    $availableTimes = $availableDay["availableTimes"];

    unset($availableDay["availableTimes"]);
    $result = false;
    if(!isset($availableDayRecord)){
        $availableDay["doc_id"] = $availableDayId;
        // print(json_encode($availableDay));
        $result = insert($table, $availableDay, $conn);
    }else{
        $result = update($table, $availableDayId, $availableDay, $conn, "doc_id");
    }

    if($result && $availableTimes){
        $result = updateAvaliableTimesOfDay( $availableDayId,$availableTimes,$conn);
    }
    return $result;
}

function updateAvaliableTimesOfDay($availableDayId,$availableTimes,$conn) {
    $result = delete_by_id("available_time_ranges", $availableDayId,$conn,'available_day_id');
    foreach($availableTimes as $availableTime){
        $date = date("ds");
        $random = (string) rand(100, 999);
        $docId = $date.$random;    
        //Add ID
        $availableTime["doc_id"] = $docId;
        $availableTime["available_day_id"] = $availableDayId;
        $result = insert("available_time_ranges", $availableTime,$conn);
    }
    return $result;
}


function checkIfDayIsFound($table,$doctorId,$availableDay,$conn) {
    $specificField = "available_day";
    $where = " doctor_id = '$doctorId'";  
    return selectRecordSpecificField($table, $specificField,"available_day",$availableDay,$conn,$where);
}
