<?php
require '../db.php';
require '../mysql.php';
require '../functions.php';

$row = ['err'=>'Error No Feilds'];

if(!empty($postdata))
{
    // Extract the data.
    $request = json_decode($postdata,true);
    if (isset($request["table"])){
        $table = $request["table"];
    }
    // fetch data by specific field
    if(isset($request["foreignKey"])){
        $foreignKey = $request["foreignKey"];
    }
    // get name , doc_id fields from another table
    if(isset($request["foreignFields"])){
        $foreignFields = $request["foreignFields"];
    }
    //for items of main table
    if(isset($request["foreignField"])){
        $foreignField = $request["foreignField"];
    }
    // get details of main table
    if (isset($request["inner_tables"])){
        $innerTables = $request["inner_tables"];
    }
    $where = '';
    if (isset($request["where"])){
        $where = $request["where"];
    }
    if(isset($request["sessionId"])){
        $sessionId = $request["sessionId"];
        $sessionData = getUserBySession($sessionId,$conn);
    }
    if (isset($request["dashboard"])){
        $dashboard = $request["dashboard"];
    }
    $withAdmin = false;
    if (isset($request["withAdmin"])){
        $withAdmin = $request["withAdmin"];
    }
    if (isset($request["filterWith"])){
        $filterWith = $request["filterWith"];
    }
    if (isset($request["lastItem"])){
        $lastItem = $request["lastItem"];
    }
    if (isset($request["rowCount"])){
        $rowCount = $request["rowCount"];
    }
    if (isset($request["getAircraftSince"])){
        $getAircraftSince = $request["getAircraftSince"];
    }
    $limitRange = array("limit"=>10,"page"=>1,"offset"=>0);
    if (isset($request["limitRange"])){
        $limitRange = $request["limitRange"];
    }
    
    $and = "";
    if(isset($table)){
        //fetch where set foreign key
        if ($where){
//            $where .= $where;
            $and = " and ";
        }

        if (isset($filterWith)){
            if (isset($sessionData) && !$sessionData["isAdmin"]){
                $userId = $sessionData["userId"];
                if($table == "orders"){
                    $where .= " ".$and." doctor_id = ".$userId;
                }else{
                    $where .= " ".$and." user_id = ".$userId;
                }
                $and = " and ";
            }
        }
        if(isset($foreignKey)){
            $key = array_keys($foreignKey)[0];
            $value = array_values($foreignKey)[0];
            $where .= " ".$and." ".$key." = '$value'";
            $and = " and ";
        }
        if(isset($foreignField) && $foreignField[array_keys($foreignField)[0]]){
            $key = array_keys($foreignField)[0];
            $value = array_values($foreignField)[0];
            $where .= " ".$and." ".$key." = '$value'";
            $and = " and ";
        }
        if (isNotAdmin($sessionData)){
//            echo json_encode("mohtady");
            $where .= $and." user_id = ".$sessionData["user_id"]." ";
        }
        if(isset($request["limitRange"])){
            $rowAll = fetch_all($table,$conn,$where);
            $limit =  $limitRange["limit"];
            $page = $limitRange["page"];
            $offset = ($page - 1) * $limit;
            $row = fetch_all($table,$conn,$where,$limit,$offset);
        }else{
            $row = fetch_all($table,$conn,$where);
        }
        if (isset($lastItem)){
            $newRows = [];
            $lastItemRow = [];
            foreach ($row as $item){
                $fieldSetIn = $lastItem["fieldSetIn"];
                $where = " item_id = ".$item["item_id"]." and aircraft_id = ".$item["aircraft_id"]." ";
                $rowsData = fetch_all($lastItem["table"],$conn,$where,'DESC',1);
                if ($rowsData){
                    $lastItemRow = array("created_at"=>$rowsData[0]["created_at"],"serial_no"=>$rowsData[0]["serial_no"]);
                }
                $item[$fieldSetIn] = $lastItemRow;
                $newRows[] = $item;
            }
            $row = $newRows;
        }
        if (isset($foreignFields)){
            $row = getForeignsTables($row,$foreignFields,$conn);
        }
        if (isset($rowCount)){
            $row = array("data"=>$row,"rowCount"=> count($row));
        }

    
    }
//
    if (isset($request["field1"]) ){
        $field_1 = $request["field1"];
        $id_1 = $request["id"];
        $row = innerSelectDeep("$table","$field_1","$id_1",
            "","","","", $conn);
    }

    if (isset($innerTables)){
        $tables = $innerTables["tables"];
        $foreignField = $innerTables["foreignField"];
        if (isset($innerTables["get_length"])){
            $get_length = $innerTables["get_length"];
        }
        foreach ($tables as $innerTable){
            $finalRow = [];
            foreach ($row as $rowItem){
                $innerRows = innerSelectDeep("$innerTable",$foreignField,$rowItem["doc_id"],
                    "","","","", $conn);
//                $rowItem[$innerTable] = $innerRows;
                $foreignList = [array("field"=>"item_id","table"=>"items")];
                $rowItem[$innerTable] = getForeignsTables($innerRows,$foreignList,$conn);
                if (isset($get_length) && $get_length){
                    $rowItem[$innerTable] = count($rowItem[$innerTable]);
                }
                $finalRow[] = $rowItem;
            }
            $row = $finalRow;
        }
//        $id_1 = $request["id"];
    }

    if (isset($request["dashboard"]) && isset($sessionData)){
        $dashboardTables = $request["dashboard"];
        foreach ($dashboardTables as $item){
            $table = $item["table"];
            $department = false;
            $sumField = "";
            if ($table == "final_money"){
                $itemObject["total"] = getWalletBalance($conn);
            }else{
                if (isset($item["sumField"])){
                    $sumField = $item["sumField"];
                }
                if (isset($item["department"])){
                    $department = $item["department"];
                }
                if (isset($item["foreignKey"])){
                    $foreignKey = $item["foreignKey"];
                    $row = getWithDepart($sessionData,$table,$conn,$department,$foreignKey);
                }else if (isset($item["where"])){
                    $where = $item["where"];
                    $row = fetch_all($table,$conn,$where);
                }else{
                    $row = getWithDepart($sessionData,$table,$conn,$department);
                }
                $itemObject["total"] = getTotal($row,$sumField);
//            $itemObject["row"] = $row;
                $itemObject["count"] = count($row);
            }

            $finalRow["tables"][] = $itemObject;
            $object = [];
        }
        if (isset($userRow["role"])){
            $finalRow["role"] = $userRow["role"];
            $finalRow["session"]["sessionId"] = $sessionId;
            $finalRow["session"]["name"] = $userRow["name"];
            if ((int) $finalRow["role"] == 2){
                $finalRow["session"]["isAdmin"] = true;
            }else{
                $finalRow["session"]["isAdmin"] = false;
            }
        }
//        $total = 0;
//        foreach ($finalRow[$table] as $value){
////            echo json_encode($value["count"]);
//            $total += $value["count"];
//        }
//        $finalRow[$table."Count"] = $total;
        $row = $finalRow;
    }
}
if(isset($request["limitRange"])){
    $result = array("data"=>$row,"rowsCount"=> count($rowAll));
}else{
    $result = $row;
}

echo json_encode($result);
mysqli_close($conn);


function getWithDepart($sessionData,$table,$conn,$department = false,$foreignKey = array()){
//    $row = [];
    $where = "";
    $depType = 1;
    // $depType = (int) $sessionData["permissiartmeonType"];
    $departmentId = "";
    // $departmentId = $sessionData["departmentId"];
    if ($foreignKey && $departmentId){
        $key = array_keys($foreignKey)[0];
        $value = array_values($foreignKey)[0];
        $where = $key." = ".$value;
        if($department){
            if ($depType == 0){
                $where = "department_id = ".$departmentId." and ".$key." = ".$value;
            }else if ($depType > 0 && $depType < 4 ){
                $where = "operation_status = ".$depType." and ".$key." = ".$value;
            }
        }
    }else{
        if($department){
            if ($depType == 0){
                $where = "department_id = ".$departmentId;
            }else if ($depType > 0 && $depType < 4 ){
                $where = "operation_status = ".$depType;
            }
        }
    }

    return fetch_all($table,$conn,$where);
}

function isNotAdmin($sessionData){
    if(isset($withAdmin) && $withAdmin){
        if(isset($sessionData["isAdmin"]) && $sessionData["isAdmin"]){
            return false;
        }else{
            return true;
        }
    }else{
       return false;
    }
}